#-*- coding: utf-8 -*-
#
# Script_ABR_1.py

class Cell:
    def __init__(self,  x):
        self.val  =  x
        self.next  =  None

class Pile:
    def __init__(self):
        self.lst  =  []
    
    def estVide(self):
        return self.lst  ==  []
    
    def empiler(self, x):
        self.lst.append(x)
    
    def depiler(self):
        if self.estVide():
            raise ValueError("pile  vide")
        return self.lst.pop()

    def afficher(self):
        """afficher le contenu de la pile"""
        imprimeElement(self.lst)


class File:
    def __init__(self):
        self.inbox  =  Pile()
        self.outbox =  Pile()
        
    def enfiler(self, x):
        self.inbox.empiler(x)
        
    def defiler(self):
        if self.estVide():
            return "Impossible file Vide"
        if self.outbox.estVide():
            while  not self.inbox.estVide():
                self.outbox.empiler(self.inbox.depiler())
        return self.outbox.depiler()
        
    def estVide(self):
        return self.inbox.estVide() and self.outbox.estVide()

class Noeud:
    def __init__(self, x, fils_gauche=None, fils_droit=None):
        self.val = x
        self.fg = fils_gauche
        self.fd = fils_droit
   

def nouveauNoeud(x, arbre_gauche, arbre_droit):
    '''
    Créé un noeud de valeur x en associant un sous arbre
    gauche et un sous arbre droit.
    '''
    return Noeud(x, arbre_gauche, arbre_droit)

def ajoute(x, a):
    '''
    Ajoute un noeud à un arbre binaire de recherche.
    Si la valeur est déjà existante alors on ne rajoute rien
    '''





    
def imprimeArbreNiveau(niveau,arbre):
    '''
    Affiche les éléments de a dans un parcours préfixe
    Traiter la racine d'abord
    '''
    decalage = '---'*niveau
    if arbre is None:
        print(' ',decalage,'o')
        return
    if niveau==0:
        print(decalage,arbre.val)
    else:
        print(' ',decalage,arbre.val)        
    imprimeArbreNiveau(niveau+1,arbre.fg)
    imprimeArbreNiveau(niveau+1,arbre.fd)
    
def imprimeArbre(arbre):
    '''
    Appel de la fonction récursive d'impression des arbres
    Le niveau 0 sert à gérer les décalages successifs à 
    l'affichage
    '''
    imprimeArbreNiveau(0,arbre)
        
## Création d'un arbre à partir d'une liste de valeurs
liste_valeurs = [8,3,10,1,6,14,4,7,13]
mon_arbre = None
for val in liste_valeurs:
    mon_arbre = ajoute(val,mon_arbre)
imprimeArbre(mon_arbre)

